# MAIN IMPORTS ================================================================================================================================================ #
from __future__ import with_statement
import psyco
psyco.full()
import es
import os
import gamethread
import random
import cmdlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func = es.import_addon('sam/functions')

# '''''''''''''''''''' # Addon/Mod Info # '''''''''''''''''' #
addon = es.AddonInfo()
addon.name     = 'Adverts'
addon.basename = 'adverts'
addon.status   = 1
addon.version  = '1.1.pub'
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# * VARIABLES

file = 'cstrike/cfg/sam/adverts.txt'
temp = {'last':'None','delay':30}

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Addon State ###
	es.set('sam_' + addon.basename, 1)

	### CMDs ###
	cmdlib.registerServerCommand('sam_adverts_delay', delayCMD, 'SAM')

	### Create Files ###
	createFile()
	createCFG()

	### Start Loop ###
	gamethread.delayedname(5, 'sam_adverts_loop', sendmsg, ())

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Addon State ###
	es.set('sam_' + addon.basename, 0)

	### Unreg ###
	cmdlib.unregisterServerCommand('sam_adverts_delay')

	### Cancel Load Delay ###
	gamethread.cancelDelayed('sam_adverts_loop')

	### Popups ###
	func.popupDelete('rules')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def delayCMD(args):
	try:
		if args:
			value = int(''.join(args))
			temp['delay'] = value
	except: pass

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def sendmsg():
	list = getAds()
	try: list.remove(temp['last'])
	except: pass
	temp['last'] = random.choice(list)
	func.tell('#all', temp['last'])
	gamethread.delayedname(temp['delay'], 'sam_adverts_loop', sendmsg, ())

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def getAds():
	if os.path.isfile(file) == True:
		with open(file) as f: return [line.strip('-').strip(' ').strip('\n') for line in f.readlines() if line.startswith('-')]
	else: return []

# ============================================================================================================================================================= #
# ========================================================================= BLOCKS ============================================================================ #
# ============================================================================================================================================================= #
def createFile():
	if os.path.isfile(file) == False:
		f = open(file,'w')
		f.write('# - - - - - - - - - - - - - - - - - #\n')
		f.write('#  Source Admin Menu # Adverts file #\n')
		f.write('# - - - - - - - - - - - - - - - - - #\n')
		f.write('#\n')
		f.write('#  This file contains all your server advertisements.\n')
		f.write('#\n')
		f.write('#  To add an advert,\n')
		f.write('#  Start the line with a - and the message next to it.\n')
		f.write('#\n')
		f.write('#  # IMPORTANT NOTES:\n')
		f.write('#  - You can use colors by following the examples below,\n')
		f.write('#    for more colors check the colors.txt file in cfg/sam folder.\n')
		f.write('#  - Messages will apear randomly every 45 seconds.\n')
		f.write('# \n')
		f.write('# - - - - - - - - - - - - - - - - - -\n')
		f.write(' \n')
		f.write('- #beigeWelcome to our server, have fun! :)\n')
		f.write('- #beigeNeed #cyanAdmin #beigehelp? Type #red!admins #beigeto see who is online.\n')
		f.write('- #redFriendly Fire #beigestatus? Type #red!ff #beigeto check it out.\n')
		f.write('- #redAlltalk #beigestatus? Type #red!alltalk #beigeto check it out.\n')
		f.write('- #beigeIf you like the server add it to favourites! :)\n')
		f.write('- #beigeBe nice and respect the server #red!rules#beige!\n')
		f.write('- #beigeAvoid fights, it is way better when everyone gets along\n')
		f.write('- #beigeWant to send a message to #cyanAdmins#beige only? Start typing with #red##beige.\n')

# :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def createCFG():
	if os.path.isfile(func.dir_addonscfg + addon.basename + '.cfg') == False:
		f = open(func.dir_addonscfg + addon.basename + '.cfg','w')
		f.write('// - - - - - - - - - - - - - - - - - - - - - - - - - - - - #\n')
		f.write('//  Source Admin Menu # Adverts configuration file #\n')
		f.write('// - - - - - - - - - - - - - - - - - - - - - - - - - - - - #\n')
		f.write(' \n')
		f.write('// The time in seconds between every advert message.\n')
		f.write('//\n')
		f.write('// Default: 30 seconds.\n')
		f.write('   sam_adverts_delay "30"\n')

# ============================================================================================================================================================= #